﻿namespace Spider.Core
{
    public class DataCollectContextBuilder
    {
        private DataCollectorOptions _options;
        private int _checkPointId;
        private int _totalSizeProcessed;

        public DataCollectContextBuilder AddCheckPoint(int checkPointId)
        {
            _checkPointId = checkPointId;

            return this;
        }

        public DataCollectContextBuilder AddTotalSize(int totalSizeProcessed)
        {
            _totalSizeProcessed = totalSizeProcessed;

            return this;
        }

        public DataCollectContextBuilder AddOptions(DataCollectorOptions options)
        {
            _options = options;

            return this;
        }

        public DataCollectContext Build()
        {
            var context = new DataCollectContext
            {
                CheckPointId = _checkPointId,
                TotalSizeProcessed = _totalSizeProcessed,
                LargeBatchSize = (int)(_options.ProcessFactor * _totalSizeProcessed)
            };

            return context;
        }
    }
}
