﻿using System.Collections.Generic;
using System.Threading.Tasks;

namespace Spider.Core.DataProvider
{
    public interface IDataProvider<T>
    {
        /// <summary>
        /// 获取批数据
        /// </summary>
        /// <returns></returns>
        Task<IEnumerable<T>> GetAsync(DataCollectContext context);

        /// <summary>
        /// 获取检查点标识
        /// </summary>
        /// <returns></returns>
        Task<int> GetCheckPointIdAsync();

        /// <summary>
        /// 获取总数
        /// </summary>
        /// <returns></returns>
        Task<int> GetCountAsync();
    }
}
