﻿using System.Threading.Tasks;

namespace Spider.Infrastructure
{
    public interface IExecutor
    {
        /// <summary>
        /// Execute the given commands asynchronously in other thread.
        /// </summary>
        /// <param name="command">Needs to be executed.</param>
        /// <param name="state">The status data passed to the command.</param>
        /// <returns></returns>
        Task ExecuteAsync<TState>(IRunnable command, TState state);
    }
}
